'==========================================='
' Debug Server v.1.2
' by B. Aslan
'==========================================='

#COMPILE EXE "DebugServer.Exe"
#DIM ALL
#IF NOT %DEF(%WINAPI)
    #INCLUDE "WIN32API.INC"
    #INCLUDE "COMDLG32.INC"
#ENDIF
#INCLUDE "PBForms.INC"
'--------------------------------------------------------------------------------
#PBFORMS BEGIN CONSTANTS
%DLG_DEBUGSERVER =  101
%TXT_DBG         = 1001
%CHK_ONTOP       = 1002
%CMD_CLEAR       = 1003
%CMD_EXIT        = 1004
%CMD_SAVE        = 1005
%CHK_LOCK        = 1006
%LBL_IPT         = 1007
%CHK_SCROLL      = 1008
%CHK_TIME        = 1009
#PBFORMS END CONSTANTS


'--------------------------------------------------------------------------------
DECLARE CALLBACK FUNCTION ShowDebugServerProc ()
DECLARE FUNCTION          ShowDebugServer (BYVAL hParent AS DWORD) AS LONG
#PBFORMS DECLARATIONS
'--------------------------------------------------------------------------------
DECLARE CALLBACK FUNCTION ShowARRVIEWProc()
DECLARE FUNCTION ShowARRVIEW(BYVAL hParent AS DWORD) AS LONG


' Minimal height and width of debug server window
%DLG_MIN_WIDTH = 263 ' minimal window width
%DLG_MIN_HEIGHT = 48  ' minimal window height

GLOBAL file_name AS STRING, hwndMain     AS LONG, _
       lock_x    AS LONG,   lock_y       AS LONG, _     ' dialog units
       CtrlSize  AS LONG,   ShowTime     AS LONG, _
       FontName  AS STRING, FontChanged  AS LONG, _
       hFontTxt  AS LONG,   FontSize     AS LONG, _
       OldProc   AS LONG

%DEBUGCLIENT = %FALSE

#INCLUDE "DebugConst.inc"

MACRO GetDebugContent         = CONTROL GET TEXT CBHNDL, %TXT_DBG TO sTxt
MACRO SetDebugContent ( txt ) = CONTROL SET TEXT CBHNDL, %TXT_DBG,   sTxt
MACRO SetDebugIPT     ( txt ) = CONTROL SET TEXT CBHNDL, %LBL_IPT,   sIPT
MACRO GetDebugIPT             = CONTROL GET TEXT CBHNDL, %LBL_IPT TO sIPT

DECLARE FUNCTION CONTROL_SET_FONT(lhDlg AS LONG, lCtlID AS LONG, sFont AS STRING, lFontSize AS LONG) AS LONG

FUNCTION PBMAIN()
   CtrlSize    =   0
   FontSize    =   9
   FontName    =   "Courier New"
   FontChanged =   %FALSE
   ShowDebugServer %HWND_DESKTOP
END FUNCTION

'--------------------------------------------------------------------------------
CALLBACK FUNCTION ShowDebugServerProc()
   LOCAL res AS LONG, ret AS LONG, sTxt AS STRING, sIPT AS STRING, lResult AS LONG, lTmp AS LONG
   LOCAL hWx AS LONG, hWy AS LONG, xDlg AS LONG, yDlg AS LONG, NeedRedraw AS LONG, sTmp AS STRING

   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
          DIALOG GET LOC CBHNDL TO lock_x, lock_y
          hwndMain = CBHNDL

      CASE %WM_MOVE
          IF CtrlSize = 0 THEN
             CONTROL GET CHECK CBHNDL, %CHK_LOCK TO res
             IF res = 1 THEN
                DIALOG SET LOC CBHNDL, lock_x, lock_y
             ELSE
                DIALOG GET LOC CBHNDL TO lock_x, lock_y
             END IF
          END IF

      CASE %WM_SIZE
          IF CtrlSize = 0 THEN
             CONTROL GET CHECK CBHNDL, %CHK_LOCK TO res
             IF res = %TRUE THEN
                DIALOG SET LOC CBHNDL, lock_x, lock_y
             END IF
             ' Stop resizing at specific position.
             '   This will stop overlapping of the EXIT button over other controls.
             '   Also, make height minimal to fit at least one line of debug window
             DIALOG GET SIZE CBHNDL TO xDlg, yDlg

             IF xDlg <= %DLG_MIN_WIDTH THEN
                xDlg = %DLG_MIN_WIDTH
                NeedRedraw = %TRUE
             END IF

             IF yDlg <= %DLG_MIN_HEIGHT THEN
                yDlg  = %DLG_MIN_HEIGHT
                NeedRedraw = %TRUE
             END IF

             IF NeedRedraw = %TRUE THEN
                DIALOG SET SIZE CBHNDL, xDlg, yDlg
                DIALOG REDRAW   CBHNDL
                NeedRedraw = %FALSE
             END IF

             ' Now, the dialog's position has been fixed on screen, but can be resized
             DIALOG GET CLIENT CBHNDL TO hWx, hWy
             CONTROL SET SIZE  CBHNDL, %TXT_DBG, hWx, hWy  - 11
             CONTROL SET LOC   CBHNDL, %CMD_EXIT, hWx - 43, 1
          END IF

      CASE %WM_PAINT
          ' trigger font change when we need it!
          IF FontChanged = %TRUE THEN
             hFontTxt    = CONTROL_SET_FONT (CBHNDL, %TXT_DBG, FontName, FontSize)
             FontChanged = %FALSE
          END IF

      CASE %WM_DESTROY
          Deleteobject hFontTxt

      CASE %WM_COMMAND
         SELECT CASE CBCTL

            CASE %CHK_TIME
               CONTROL GET CHECK CBHNDL, %CHK_TIME TO res
               ShowTime = res = %TRUE OR res    'replaced IIF( res = %TRUE, %TRUE, %FALSE )

            CASE %CHK_ONTOP
               CONTROL GET CHECK CBHNDL, %CHK_ONTOP TO res

               SetWindowPos ( CBHNDL, _
                              IIF( res = %TRUE, %HWND_TOPMOST, %HWND_NOTOPMOST ), _
                              0, 0, 0, 0, _
                              %SWP_NOSIZE OR %SWP_NOMOVE )

            CASE %CHK_LOCK
               CONTROL GET CHECK CBHNDL, %CHK_TIME TO CtrlSize
               CtrlSize = res = %TRUE OR res    'replaced IIF( res = %TRUE, %TRUE, %FALSE )

            CASE %CMD_CLEAR
               IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                  SetDebugContent ( "" )
               END IF

            CASE %CMD_SAVE
               DIM file AS STRING
               file = ""
               IF ISTRUE( SaveFileDialog ( CBHNDL, _
                                           "Save File", _
                                           file, _
                                           CURDIR$, _
                                           "Text files|*.txt|Log files|*.log|" & _
                                           "HTML files|*.htm|HEX files|*.hex|All Files|*.*", "txt", _
                                           %OFN_HIDEREADONLY OR %OFN_LONGNAMES )) THEN

                   CONTROL HANDLE CBHNDL, %TXT_DBG TO lResult
                   CALL SaveToFile ( file, lResult )
                   MSGBOX "Content of Debug Window stored in file " & $CRLF & _
                          UCASE$( file ), _
                          %MB_OK + %MB_APPLMODAL + %MB_ICONINFORMATION + %MB_SYSTEMMODAL, $DEBUG_SERVER_CAPTION
               END IF

            CASE %CMD_EXIT
               IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                  IF MSGBOX("Are you sure you want to Exit from DEBUG SERVER? (Y/N)", _
                            %MB_YESNO + %MB_APPLMODAL + %MB_ICONQUESTION + %MB_SYSTEMMODAL, "Warning") = %IDYES THEN
                     DIALOG END CBHNDL
                  END IF
               END IF

         END SELECT
      '*******************************************************************************
      ' User Defined messages
      '
      CASE %WM_USER + %DSRV_HWND
          ' Return hWnd for dialog (CBHNDL)
          FUNCTION = CBHNDL

      CASE %WM_USER + %DSRV_HTXT
          ' Return hWnd for %txt_dbg
          CONTROL HANDLE CBHNDL, %TXT_DBG TO lResult
          FUNCTION = lResult

      CASE %WM_USER + %DSRV_HIPT
          ' Return hWnd for %lbl_ipt
          CONTROL HANDLE CBHNDL, %LBL_IPT TO lResult
          FUNCTION = lResult

      '*******************************************************************************
      ' Debug Server Support functions
      '
      CASE %WM_USER + %DSRV_SUPP
          SELECT CASE CBCTL

             CASE  %DSRV_CLEAR
                ' Clear DEBUG window
                '
                SetDebugContent ( "" )

             CASE  %DSRV_TOPMOST
                ' Set Window TopMost (SYSTEM MODAL)
                '
                CONTROL SET CHECK CBHNDL, %CHK_ONTOP, 1
                SetWindowPos ( CBHNDL, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOSIZE OR %SWP_NOMOVE )

             CASE  %DSRV_NONTOPMOST
                ' Set Window Non TopMost
                '
                CONTROL SET CHECK CBHNDL, %CHK_ONTOP, 0
                SetWindowPos ( CBHNDL, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOSIZE OR %SWP_NOMOVE )

             CASE  %DSRV_LOCKWINDOW
                ' Lock Window in current position
                '
                CONTROL SET CHECK CBHNDL, %CHK_LOCK, 1
                CtrlSize = %TRUE

             CASE  %DSRV_UNLOCKWINDOW
                ' Unlock window from current position
                '
                CONTROL SET CHECK CBHNDL, %CHK_LOCK, 0
                CtrlSize = %FALSE

             CASE  %DSRV_SAVETOFILE
                ' Write Content to file
                '
                GetDebugIPT () ' read filename
                IF LEN( sIPT ) > 0 THEN
                   ' write to file in silent mode without notification
                   CONTROL HANDLE CBHNDL, %TXT_DBG TO lResult
                   CALL SaveToFile ( sIPT, lResult )
                END IF

             CASE  %DSRV_COPYTOCLIPBOARD
                ' Copy content of debug window into clipboard
                '
                GetDebugContent  ()
                CALL WriteToClipboard ( sTxt )
                ' notification
                MSGBOX "Content of Debug Window copied into a clipboard ", _
                          %MB_OK + %MB_APPLMODAL + %MB_ICONINFORMATION + %MB_SYSTEMMODAL, $DEBUG_SERVER_CAPTION

             CASE  %DSRV_DATALENGTH
                ' Return the length of data in bytes inside the debug window
                '
                GetDebugContent ()
                FUNCTION = LEN( sTxt )

             CASE  %DSRV_RESTORE
                ' Restore and activate the debug server window
                '
                DIALOG SHOW STATE CBHNDL, %SW_SHOW

             CASE  %DSRV_HANDSHAKE
                ' Second level of checking of running Debug Server
                '
                FUNCTION = %DSRV_HANDSHAKE

             CASE  %DSRV_ADDTEXT
                ' Add text to debug window
                '
                GetDebugIPT ()                   ' read received text from IPT control
                GetDebugContent ()               ' read content of Debug window

                IF ISTRUE ShowTime THEN
                   sIPT = TIME$ & "|" & sIPT     ' show time when it was sent to debug server
                END IF

                sTxt = sTxt & sIPT & $CRLF       ' concatenate two strings and
                SetDebugContent ( sTxt )         ' write back to debug window

                ' Does scrolling enabled?
                CONTROL GET CHECK CBHNDL, %CHK_SCROLL TO res
                IF res = %TRUE THEN
                   ' if so, then move cursor to the end of text box
                   CONTROL SEND CBHNDL, %TXT_DBG, %EM_SETSEL, LEN(sTxt), LEN(sTxt)
                   CONTROL SEND CBHNDL, %TXT_DBG, %EM_SCROLLCARET, 0, 0
                END IF

             CASE  %DSRV_ENABLESCROLL
                ' Enable textbox auto scrolling
                '
                CONTROL SET CHECK CBHNDL, %CHK_SCROLL, 1

             CASE  %DSRV_DISABLESCROLL
                ' Disable textbox auto scrolling
                '
                CONTROL SET CHECK CBHNDL, %CHK_SCROLL, 0

             CASE  %DSRV_SHOWTIME
                ShowTime = %TRUE

             CASE  %DSRV_HIDETIME
                ShowTime = %FALSE

             CASE  %DSRV_SETFONT
                GetDebugIPT ()
                FontChanged = %TRUE
                CALL RetrieveFontInfo (sIPT)
                DIALOG REDRAW CBHNDL ' force WM_PAINT

             CASE  %DSRV_MOVEWINDOW
                LOCAL wX AS LONG, wY AS LONG, dlgX AS LONG, dlgY AS LONG
                GetDebugIPT ()
                IF TALLY(sIPT, ",") > 0 THEN
                   wX = VAL(PARSE$(sIPT, 1))
                   wY = VAL(PARSE$(sIPT, 2))
                   DIALOG GET LOC CBHNDL TO dlgX, dlgY
                   IF wX = 0 THEN wX = dlgX
                   IF wY = 0 THEN wY = dlgY
                   DIALOG SET LOC CBHNDL, wX, wY
                END IF

             CASE  %DSRV_RESETDEBUGSERVER
                ' clear debug server window
                '
                SetDebugContent ( "" )
                ' clear debug server IPT
                '
                SetDebugIPT ( "" )
                ' set debug server non topmost
                '
                CONTROL SET CHECK CBHNDL, %CHK_ONTOP, 0
                SetWindowPos ( CBHNDL, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOSIZE OR %SWP_NOMOVE )
                ' unlock window
                '
                CtrlSize    = %FALSE
                CONTROL SET CHECK CBHNDL, %CHK_LOCK, 0
                ' disable textbox autoscrolling
                '
                CONTROL SET CHECK CBHNDL, %CHK_SCROLL, 0
                ' hide time
                '
                ShowTime = %FALSE
                CONTROL SET CHECK CBHNDL, %CHK_TIME, 0
                ' resetting font to Courier New, 9 pt
                '
                FontChanged = %TRUE
                FontSize    = 9
                FontName    = "Courier New"
                DIALOG REDRAW CBHNDL

             CASE  911
                ' for test purposes only - show content of IPT
                '
                GetDebugIPT ()
                MSGBOX sIPT

             'CASE %DSRV_SHOWARRAY
             CASE ELSE
          END SELECT

   END SELECT
END FUNCTION
'--------------------------------------------------------------------------------
FUNCTION ShowDebugServer(BYVAL hParent AS DWORD) AS LONG
    LOCAL lRslt AS LONG
#PBFORMS BEGIN DIALOG %DLG_DEBUGSERVER->->
    LOCAL hDlg   AS DWORD
    LOCAL hFont1 AS DWORD
    LOCAL hFont2 AS DWORD

    DIALOG NEW  hParent, $DEBUG_SERVER_CAPTION, 137, 166, 466, 148, %WS_POPUP OR _
        %WS_BORDER OR %WS_THICKFRAME OR %WS_CAPTION OR %WS_SYSMENU OR _
        %WS_CLIPSIBLINGS OR %WS_VISIBLE OR %DS_MODALFRAME OR %DS_CENTER OR _
        %DS_3DLOOK OR %DS_NOFAILCREATE OR %DS_SETFONT, %WS_EX_CONTROLPARENT _
        OR %WS_EX_TOOLWINDOW OR %WS_EX_APPWINDOW OR %WS_EX_LEFT OR _
        %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR, TO hDlg
    CONTROL ADD CHECKBOX, hDlg, %CHK_ONTOP, "O&n Top", 0, 2, 33, 8, %WS_CHILD _
        OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_TEXT OR %BS_AUTOCHECKBOX OR _
        %BS_FLAT OR %BS_LEFT OR %BS_VCENTER, %WS_EX_LEFT OR _
        %WS_EX_LTRREADING
    CONTROL ADD CHECKBOX, hDlg, %CHK_LOCK, "&Lock", 34, 1, 24, 10, %WS_CHILD _
        OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_TEXT OR %BS_AUTOCHECKBOX OR _
        %BS_FLAT OR %BS_LEFT OR %BS_VCENTER, %WS_EX_LEFT OR _
        %WS_EX_LTRREADING
    CONTROL ADD BUTTON,   hDlg, %CMD_CLEAR, "&Clear", 127, 1, 43, 10
    CONTROL ADD BUTTON,   hDlg, %CMD_SAVE, "&Save To ...", 171, 1, 43, 10
    CONTROL ADD TEXTBOX,  hDlg, %TXT_DBG, "", 0, 11, 465, 137, %WS_CHILD OR _
        %WS_VISIBLE OR %WS_BORDER OR %WS_TABSTOP OR %WS_HSCROLL OR _
        %WS_VSCROLL OR %ES_LEFT OR %ES_MULTILINE OR %ES_AUTOHSCROLL OR _
        %ES_AUTOVSCROLL OR %ES_WANTRETURN, %WS_EX_LEFT OR %WS_EX_LTRREADING _
        OR %WS_EX_RIGHTSCROLLBAR
    CONTROL ADD BUTTON,   hDlg, %CMD_EXIT, "E&xit", 423, 1, 43, 10
    CONTROL ADD LABEL,    hDlg, %LBL_IPT, "", 100, 100, 0, 0
    CONTROL ADD CHECKBOX, hDlg, %CHK_SCROLL, "Sc&roll", 60, 1, 30, 10, _
        %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_TEXT OR _
        %BS_AUTOCHECKBOX OR %BS_FLAT OR %BS_LEFT OR %BS_VCENTER, %WS_EX_LEFT _
        OR %WS_EX_LTRREADING
    CONTROL ADD CHECKBOX, hDlg, %CHK_TIME, "&Timer", 90, 1, 28, 10, _
        %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_TEXT OR _
        %BS_AUTOCHECKBOX OR %BS_FLAT OR %BS_LEFT OR %BS_VCENTER, %WS_EX_LEFT _
        OR %WS_EX_LTRREADING

    hFont1 = PBFormsMakeFont("Arial Narrow", 8, 400, %FALSE, %FALSE, %FALSE, _
        204)
    hFont2 = PBFormsMakeFont(FontName, 9, 400, %FALSE, %FALSE, %FALSE, _
        204)

    CONTROL SEND hDlg, %CHK_ONTOP, %WM_SETFONT, hFont1, 0
    CONTROL SEND hDlg, %CHK_LOCK, %WM_SETFONT, hFont1, 0
    CONTROL SEND hDlg, %CHK_SCROLL, %WM_SETFONT, hFont1, 0
    CONTROL SEND hDlg, %CHK_TIME, %WM_SETFONT, hFont1, 0
    CONTROL SEND hDlg, %CMD_CLEAR, %WM_SETFONT, hFont1, 0
    CONTROL SEND hDlg, %CMD_SAVE, %WM_SETFONT, hFont1, 0
    CONTROL SEND hDlg, %TXT_DBG, %WM_SETFONT, hFont2, 0
    CONTROL SEND hDlg, %CMD_EXIT, %WM_SETFONT, hFont1, 0
#PBFORMS END DIALOG

    lock_x = 149: lock_y = 74

    DIALOG SHOW MODAL hDlg, CALL ShowDebugServerProc TO lRslt
#PBFORMS BEGIN CLEANUP %DLG_DEBUGSERVER
    DeleteObject hFont1
    DeleteObject hFont2
#PBFORMS END CLEANUP

   FUNCTION = lRslt
END FUNCTION

'------------------------------------------------------
' Store content of debug window in file
'------------------------------------------------------
SUB SaveToFile ( BYVAL outfile AS STRING, BYVAL hTxt AS LONG)

    LOCAL FF AS INTEGER, Buffer AS STRING

    IF LEN(DIR$(outfile)) > 0 THEN KILL outfile

    FF = FREEFILE
    OPEN outfile FOR BINARY AS FF
     Buffer = SPACE$(GetWindowTextLength(hTxt) + 1)
      GetWindowText hTxt, BYVAL STRPTR(Buffer), LEN(Buffer)
       PUT$ FF, LEFT$(Buffer, LEN(Buffer) - 1)
        SETEOF FF
    CLOSE FF

END SUB

'------------------------------------------------------
' Retrieve font information via IPT
'------------------------------------------------------
$FONT_INFO_DELIM = ","

SUB RetrieveFontInfo ( BYVAL T AS STRING )
    FontName = PARSE$( T, $FONT_INFO_DELIM, 1 )
    FontSize = VAL(PARSE$( T, $FONT_INFO_DELIM, 2 ))
    FontSize = IIF(FontSize = 0, 9, FontSize)
END SUB

'------------------------------------------------------
' Copy content of debug window into a clipboard
'------------------------------------------------------
SUB WriteToClipBoard ( BYVAL Txt AS STRING )

    LOCAL MemPointer AS ASCIIZ PTR
    LOCAL hMem       AS DWORD

    hMem        = GlobalAlloc(%GHND, LEN(Txt) + 1)
    MemPointer  = GlobalLock(hMem)
    @MemPointer = Txt
    GlobalUnlock hMem
     OpenClipboard 0
      EmptyClipboard
       SetClipboardData %CF_TEXT, hMem
     CloseClipboard
    GlobalFree ( hMem )

END SUB

'
' http://www.powerbasic.com/support/forums/Forum7/HTML/002003.html
'
'/////////////////////////////////////////////////////////////////////////////
' Wrapper to set the font of a DDT control. Much like the DIALOG FONT or
' CONTROL SET COLOR commands
'
'   Author: John McWilliams
'     Date: 07/31/2003
'  Revised: no revisions
'  Depends: win32api.inc
' Platform: PBWin with DDT support for CONTROL SEND (6.11 thru 7.02)
'
' Released to the PUBLIC DOMAIN on 07/31/2003. No warranties implied as to
' suitability. Use at your own risk. You are free to modify this code as you
' see fit. You are free to include this code in any private or commercial
' product. Tested on W2K SP3
'
' Function: CONTROL_SET_FONT(lhDlg AS LONG, lCtlID AS LONG, sFont AS STRING, _
'                          lFontSize AS LONG)
'
'           lhDlg       is the HANDLE to the Dialog
'           lCtlID      is the IDENTIFIER of the Control
'           sFont       is the font name (i.e. "Verdana")
'           lFontSize   is the desired font size (i.e. 10)
'
' Returns: %NULL if it fails, font handle if it succedes
'
'   Notes: if the font doesn't exist, the font is set to the font that most
'          closely meets the criteria in CreateFont. So you might get some
'          *WIERD* font if you improperly specify the font name.
'
'   Usage: CONTROL_SET_FONT hDlg, %ID_ListBox1, "Verdana", 10
'          Result = CONTROL_SET_FONT(hDlg, %ID_ListBox1, "Verdana", 10)
'
'-----------------------------------------------------------------------------
FUNCTION CONTROL_SET_FONT(lhDlg     AS LONG, lCtlID AS LONG, sFont AS STRING, _
                          lFontSize AS LONG) AS LONG
    LOCAL hDC       AS DWORD
    LOCAL CyPixels  AS LONG
    LOCAL hFont     AS LONG

    hDC       =  GetDC(%HWND_DESKTOP)
    CyPixels  =  GetDeviceCaps(hDC, %LOGPIXELSY)
    ReleaseDC    %HWND_DESKTOP, hDC
    lFontSize = (lFontSize * CyPixels) \ 72
    hFont     = CreateFont(0 - lFontSize, 0, 0, 0, %FW_NORMAL, 0, 0, 0, _
                %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
                %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
    '
    FUNCTION = hFont
    IF ISFALSE hFont THEN EXIT FUNCTION  'don't bother to send anything, it failed
    CONTROL SEND lhDlg, lCtlID, %WM_SETFONT, hFont, 1
    '
END FUNCTION
